// ST_CBtn.cpp : implementation file
//

#include "stdafx.h"
#include "ST_CBtn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ST_CButton

ST_CButton::ST_CButton()
{
#ifdef ST_FLAT_BUTTONS
  m_MouseOnButton = FALSE;
#endif

  m_hIcon = NULL;
  m_cxIcon = 0;
  m_cyIcon = 0;
} // End of ST_CButton


BEGIN_MESSAGE_MAP(ST_CButton, CButton)
	//{{AFX_MSG_MAP(ST_CButton)
	//}}AFX_MSG_MAP
#ifdef ST_FLAT_BUTTONS
  ON_WM_MOUSEMOVE()
  ON_WM_KILLFOCUS()
#endif  
END_MESSAGE_MAP()


void ST_CButton::DrawItem(LPDRAWITEMSTRUCT lpDIS)
{
  CDC* pDC = CDC::FromHandle(lpDIS->hDC);

  unsigned int IsPressed  = (lpDIS->itemState & ODS_SELECTED);
  unsigned int IsFocused  = (lpDIS->itemState & ODS_FOCUS);
  unsigned int IsDisabled = (lpDIS->itemState & ODS_DISABLED);

  CRect itemRect = lpDIS->rcItem;

#ifndef ST_FLAT_BUTTONS
  if (IsFocused)
  {
    CBrush br(RGB(0,0,0));  
    pDC->FrameRect(&itemRect, &br);
    itemRect.DeflateRect(1, 1);
  }
#endif

  // Disegno lo sfondo del bottone
  CBrush br(GetSysColor(COLOR_BTNFACE));  
  pDC->FillRect(&itemRect, &br);

  // Disegno il bottone premuto...
  if (IsPressed)
  {
#ifdef ST_FLAT_BUTTONS
	CPen penBtnHiLight(PS_SOLID, 0, GetSysColor(COLOR_BTNHILIGHT)); // Bianco
    CPen penBtnShadow(PS_SOLID, 0, GetSysColor(COLOR_BTNSHADOW));   // Grigio scuro

    // Disegno i bordi a sinistra e in alto
    // Linea grigio scuro
    pDC->SelectObject(penBtnShadow);
    pDC->MoveTo(itemRect.left, itemRect.bottom-1);
    pDC->LineTo(itemRect.left, itemRect.top);
    pDC->LineTo(itemRect.right, itemRect.top);
    // Disegno i bordi a destra e in basso
    // Linea bianca
    pDC->SelectObject(penBtnHiLight);
    pDC->MoveTo(itemRect.left, itemRect.bottom-1);
    pDC->LineTo(itemRect.right-1, itemRect.bottom-1);
    pDC->LineTo(itemRect.right-1, itemRect.top-1);
#else    
    CBrush brBtnShadow(GetSysColor(COLOR_BTNSHADOW));
    pDC->FrameRect(&itemRect, &brBtnShadow);
#endif    
  }
  else // ...oppure il bottone non premuto
  {
    CPen penBtnHiLight(PS_SOLID, 0, GetSysColor(COLOR_BTNHILIGHT)); // Bianco
    CPen pen3DLight(PS_SOLID, 0, GetSysColor(COLOR_3DLIGHT));       // Grigio chiaro
    CPen penBtnShadow(PS_SOLID, 0, GetSysColor(COLOR_BTNSHADOW));   // Grigio scuro
    CPen pen3DDKShadow(PS_SOLID, 0, GetSysColor(COLOR_3DDKSHADOW)); // Nero

#ifdef ST_FLAT_BUTTONS
    if (m_MouseOnButton == TRUE)
    {
      // Disegno i bordi a sinistra e in alto
      // Linea bianca
      pDC->SelectObject(penBtnHiLight);
      pDC->MoveTo(itemRect.left, itemRect.bottom-1);
      pDC->LineTo(itemRect.left, itemRect.top);
      pDC->LineTo(itemRect.right, itemRect.top);
      // Disegno i bordi a destra e in basso
      // Linea grigio scuro
      pDC->SelectObject(penBtnShadow);
      pDC->MoveTo(itemRect.left, itemRect.bottom-1);
      pDC->LineTo(itemRect.right-1, itemRect.bottom-1);
      pDC->LineTo(itemRect.right-1, itemRect.top-1);
    }
#else
    // Disegno i bordi a sinistra e in alto
    // Linea bianca
    pDC->SelectObject(penBtnHiLight);
    pDC->MoveTo(itemRect.left, itemRect.bottom-1);
    pDC->LineTo(itemRect.left, itemRect.top);
    pDC->LineTo(itemRect.right, itemRect.top);
    // Linea grigio chiaro
    pDC->SelectObject(pen3DLight);
    pDC->MoveTo(itemRect.left+1, itemRect.bottom-1);
    pDC->LineTo(itemRect.left+1, itemRect.top+1);
    pDC->LineTo(itemRect.right, itemRect.top+1);
    // Disegno i bordi a destra e in basso
    // Linea nera
    pDC->SelectObject(pen3DDKShadow);
    pDC->MoveTo(itemRect.left, itemRect.bottom-1);
    pDC->LineTo(itemRect.right-1, itemRect.bottom-1);
    pDC->LineTo(itemRect.right-1, itemRect.top-1);
    // Linea grigio scuro
    pDC->SelectObject(penBtnShadow);
    pDC->MoveTo(itemRect.left+1, itemRect.bottom-2);
    pDC->LineTo(itemRect.right-2, itemRect.bottom-2);
    pDC->LineTo(itemRect.right-2, itemRect.top);
#endif    
  }

#ifndef ST_FLAT_BUTTONS
  // Disegno il focus rect
  if (IsFocused)
  {
    CRect focusRect = itemRect;
    focusRect.DeflateRect(3, 3);
    pDC->DrawFocusRect(&focusRect);
  }
#endif

  // Leggo il titolo del bottone
  CString title;
  GetWindowText(title);

  // Disegno l'icona
  if (m_hIcon != NULL)
  {
    CRect iconRect = lpDIS->rcItem;
    // Se il bottone non ha un titolo allora centro l'icona orizzontalmente
    if (title.IsEmpty() == TRUE)
    {
      iconRect.left += ((iconRect.Width() - m_cxIcon)/2);
    }
    else
    {
      // L'icona deve vedersi subito dentro il focus rect
      iconRect.left += 6;  // 3 per stare dentro al focus rect e 3 per non starci
                           // proprio attaccata
    }
    // Centro l'icona verticalmente
    iconRect.top += ((iconRect.Height() - m_cyIcon)/2);
    // Se il bottone e' premuto allora 'premo' di conseguenza l' icona
    if (IsPressed) iconRect.OffsetRect(1, 1);
    // Ole'!
    pDC->DrawIcon(iconRect.TopLeft(), m_hIcon);
  }

  CRect captionRect = lpDIS->rcItem;
  // Restringo lo spazio dedicato al titolo se c'e' un'icona
  captionRect.left += m_cxIcon;

  // Scrivo la caption solo se non e' una stringa nulla
  if (title.IsEmpty() == false)
  {
    // Disegno la caption del bottone
    pDC->SetBkMode(TRANSPARENT);
    // Restringo la captionRect comprendendo sempre il FocusRect
    // in modo che sia l' icona che il titolo vengano sempre centrati
    // all' interno dell' eventuale FocusRect
    captionRect.OffsetRect(0, -1);
    // Se il bottone e' premuto muovo la captionRect di conseguenza
    if (IsPressed)
      captionRect.OffsetRect(1, 1);
    
    // SOLO PER DEBUG 
    // Evidenzia il rettangolo in cui verra' centrata la caption 
    // CBrush brBtnShadow(RGB(255, 0, 0));
    // pDC->FrameRect(&captionRect, &brBtnShadow);

    // Se il bottone e' disabilitato...
    if (IsDisabled)
    {
      captionRect.OffsetRect(1, 1);
      pDC->SetTextColor(RGB(255, 255, 255)); // Bianco
      pDC->DrawText(title, -1, captionRect, DT_SINGLELINE|DT_CENTER|DT_VCENTER);
      captionRect.OffsetRect(-1, -1);
      pDC->SetTextColor(GetSysColor(COLOR_GRAYTEXT));
      pDC->DrawText(title, -1, captionRect, DT_SINGLELINE|DT_CENTER|DT_VCENTER);
    }
    else // ...oppure no
    {
      pDC->DrawText(title, -1, captionRect, DT_SINGLELINE|DT_CENTER|DT_VCENTER);
    }
  }
} // End of DrawItem


void ST_CButton::SetIcon(HICON hIcon, BYTE cx, BYTE cy)
{
  m_hIcon = hIcon;
  m_cxIcon = cx;
  m_cyIcon = cy;
} // End of SetIcon


BOOL ST_CButton::SubclassDlgItem(UINT nID, CWnd * pParent)
{
  BOOL retValue = CButton::SubclassDlgItem(nID, pParent);
  
  // Add BS_OWNERDRAW style
  LONG bs = ::GetWindowLong(m_hWnd, GWL_STYLE);
  bs |= BS_OWNERDRAW;
  ::SetWindowLong(m_hWnd, GWL_STYLE, bs);
  
  return retValue;
} // End of SubclassDlgItem


const char* ST_CButton::GetVersionC()
{
  return "1.1";
} // End of GetVersionC


const short ST_CButton::GetVersionI()
{
  return 11; // Divide by 10 to get the real version
} // End of GetVersionI


#ifdef ST_FLAT_BUTTONS
void ST_CButton::OnMouseMove(UINT nFlags, CPoint point)
{
  CWnd* pWnd;  // Finestra attiva
  CWnd* pParent; // Finestra che contiene il bottone

  CButton::OnMouseMove(nFlags, point);

  pWnd = GetActiveWindow();
  pParent = GetOwner();

  if ((m_MouseOnButton == FALSE) && (GetCapture() != this) &&
      ((pWnd != NULL) && (pWnd->m_hWnd == pParent->m_hWnd))) 
  {
    SetCapture();
	SetFocus();
    m_MouseOnButton = TRUE;
    Invalidate();
    UpdateWindow();
  }
  else
  {
    CRect rc;
    GetClientRect(&rc);
    if (!rc.PtInRect(point))
    {
      m_MouseOnButton = FALSE;
      Invalidate();
      UpdateWindow();
      ReleaseCapture();
    }
  }
}
#endif


#ifdef ST_FLAT_BUTTONS
void ST_CButton::OnKillFocus(CWnd * pNewWnd)
{
  CButton::OnKillFocus(pNewWnd);
  if (m_MouseOnButton == TRUE)
  {
    m_MouseOnButton = FALSE;
    Invalidate();
    UpdateWindow();
  }
} // End of OnKillFocus
#endif
